<template>
  <div class="comment">
    <a-comment>
      <span slot="datetime">{{ comment.create_time }}</span>
      <a slot="author" style="font-size: 15px">{{ comment.user_name }}</a>
      <a-avatar slot="avatar" style="backgroundColor:#87d068" icon="user"/>
      <p slot="content" v-html="comment.content"></p>
      <template slot="actions">
        <span key="comment-basic-like">
          <a-icon type="like" :theme="action === 'liked' ? 'filled' : 'outlined'" @click="like"/>
          <span style="'padding-left': '8px';cursor: auto"> {{comment.agree_count}}</span>
        </span>
        <span key="comment-basic-dislike">
          <a-icon
              type="dislike"
              :theme="action === 'disliked' ? 'filled' : 'outlined'"
              @click="dislike"
          />
          <span style="'padding-left': '8px';cursor: auto"> {{comment.oppo_count}}</span>
        </span>
        <span key="comment-basic-reply-to" @click="replyTo">{{ comment.reply ? '取消回复' : '回复' }}</span>
        <a v-if="user_info.user_type === 'admin' || user_info.user_id === comment.user_id" style="color: #ff3434" @click="deleteReply">删除</a>
      </template>
    </a-comment>
    <div v-if="comment.reply" class="reply-block">
      <a-input  v-model="content" type="textarea" :maxLength="200" :placeholder="placeholder" :rows="4"/>
      <a-button :loading="loading" :disabled="content === ''" type="primary" @click="handleSend">发 表</a-button>
    </div>
    <div class="child">
      <slot name="childComment"></slot>
    </div>
  </div>
</template>

<script>
import {mapActions, mapState} from "vuex";

export default {
  name: "Comment",
  data() {
    return {
      action: '',
      replyFlag: false,
      content: "",
      loading: false,
      placeholder: ""
    }
  },
  props: {
    comment: {
      type: Object,
      default: () => ({})
    }
  },

  computed: {
    ...mapState('user', ['user_info']),
    ...mapState('discuss', ['post_id'])
  },
  methods: {
    ...mapActions('discuss', ['getCommentList']),
    handlReply(comment) {
      this.$emit("handleReply", comment);
    },

    like() {
      this.$axios.post('comment/agree', {
        comment_id: this.comment.comment_id,
        post_id: this.comment.post_id
      }).then(res => {
        if (res.code == 0) {
          this.getCommentList()
        } else if (res.code == 501) {
          this.$notification.warn({message: res.info})
        } else {
          this.$notification.error({message:'操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message:'操作失败'})
      })
    },
    dislike() {
      this.$axios.post('comment/oppo', {
        comment_id: this.comment.comment_id,
        post_id: this.comment.post_id
      }).then(res => {
        if (res.code == 0) {
          this.getCommentList()
        } else if (res.code == 501) {
          this.$notification.warn({message: res.info})
        } else {
          this.$notification.error({message:'操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message:'操作失败'})
      })
    },

    replyTo() {
      this.$emit('replySwitch', this.comment.comment_id, this.comment.reply_id)
      this.placeholder = `回复${this.comment.user_name}:（限制在200字以内）`
    },

    async handleSend() {
      this.loading = true;
      let content = this.comment.reply_id ? `${this.content} // <a>@${this.comment.user_name}</a> : ${this.comment.content.split('// <a>')[0]}` : this.content
      await this.$axios.post('comment/reply', {
        post_id: Number(this.post_id),
        content: content,
        comment_id: this.comment.reply_id || this.comment.comment_id,
        reply_id: this.comment.reply_id ? this.comment.comment_id : undefined
      }).then(res => {
        if (res.code == 0) {
          this.content = "";
          this.getCommentList()
        } else {
          this.$notification.error({message: '提交失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '提交失败'})
      });
      this.loading = false;
    },

    deleteReply() {
      this.$axios.post('comment/delete', {
        comment_id: this.comment.comment_id
      }).then(res => {
        if (res.code == 0) {
          this.getCommentList()
        } else {
          this.$notification.error({message:'操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message:'操作失败'})
      })
    }
  }
};
</script>

<style lang="less" scoped>
.reply-to {
  padding-left: 5px;
  color: #409eff;
  font-weight: 500;
  font-size: 15px;
}
.reply-block {
  display: flex;
  align-items: end;
  padding-left: 44px;
  /deep/ .ant-btn {
    margin-left: 20px;
  }
}
/deep/ .ant-comment-inner {
  padding-bottom: 0;
}
.child {
  padding-left: 44px;
}
</style>